from http import HTTPStatus
from typing import Any
from urllib.parse import quote

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.get_todo_task_task_response_400 import GetTodoTaskTaskResponse400
from ...models.get_todo_task_task_response_404 import GetTodoTaskTaskResponse404
from ...models.pkg_routes_todo_task_get_task_response import PkgRoutesTodoTaskGetTaskResponse
from ...types import UNSET, Response, Unset


def _get_kwargs(
    task: str,
    *,
    minimal: str | Unset = UNSET,
) -> dict[str, Any]:

    params: dict[str, Any] = {}

    params["minimal"] = minimal

    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}

    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": "/todo/task/{task}".format(
            task=quote(str(task), safe=""),
        ),
        "params": params,
    }

    return _kwargs


def _parse_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse | None:
    if response.status_code == 200:
        response_200 = PkgRoutesTodoTaskGetTaskResponse.from_dict(response.json())

        return response_200

    if response.status_code == 400:
        response_400 = GetTodoTaskTaskResponse400.from_dict(response.json())

        return response_400

    if response.status_code == 404:
        response_404 = GetTodoTaskTaskResponse404.from_dict(response.json())

        return response_404

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> Response[GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    task: str,
    *,
    client: AuthenticatedClient,
    minimal: str | Unset = UNSET,
) -> Response[GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse]:
    """Get task

     Get task details with optional client, project, message, meeting, and activity data

    Args:
        task (str):
        minimal (str | Unset):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse]
    """

    kwargs = _get_kwargs(
        task=task,
        minimal=minimal,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    task: str,
    *,
    client: AuthenticatedClient,
    minimal: str | Unset = UNSET,
) -> GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse | None:
    """Get task

     Get task details with optional client, project, message, meeting, and activity data

    Args:
        task (str):
        minimal (str | Unset):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse
    """

    return sync_detailed(
        task=task,
        client=client,
        minimal=minimal,
    ).parsed


async def asyncio_detailed(
    task: str,
    *,
    client: AuthenticatedClient,
    minimal: str | Unset = UNSET,
) -> Response[GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse]:
    """Get task

     Get task details with optional client, project, message, meeting, and activity data

    Args:
        task (str):
        minimal (str | Unset):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse]
    """

    kwargs = _get_kwargs(
        task=task,
        minimal=minimal,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    task: str,
    *,
    client: AuthenticatedClient,
    minimal: str | Unset = UNSET,
) -> GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse | None:
    """Get task

     Get task details with optional client, project, message, meeting, and activity data

    Args:
        task (str):
        minimal (str | Unset):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        GetTodoTaskTaskResponse400 | GetTodoTaskTaskResponse404 | PkgRoutesTodoTaskGetTaskResponse
    """

    return (
        await asyncio_detailed(
            task=task,
            client=client,
            minimal=minimal,
        )
    ).parsed
